#include <core/type_util.hpp>
#include <object/Object.h>
#include <ext/typeinfo>

namespace core {

std::unique_ptr < type_details_base > type_util < long unsigned >::type ( long unsigned ) {
	if constexpr ( std::is_same_v < long unsigned, size_t > ) {
		core::unique_ptr_set < type_details_base > types;
		types.insert ( std::make_unique < type_details_type > ( "long unsigned" ) );
		types.insert ( std::make_unique < type_details_type > ( "size_t" ) );
		return std::make_unique < type_details_variant_type > ( std::move ( types ) );
	} else {
		return std::make_unique < type_details_type > ( "long unsigned" );
	}
}

// ----------------------------------------------------------------------------------------------------------------

std::unique_ptr < type_details_base > type_util < unsigned >::type ( unsigned ) {
	return std::make_unique < type_details_type > ( "unsigned" );
}

// ----------------------------------------------------------------------------------------------------------------

std::unique_ptr < type_details_base > type_util < long >::type ( long ) {
	return std::make_unique < type_details_type > ( "long" );
}

// ----------------------------------------------------------------------------------------------------------------

std::unique_ptr < type_details_base > type_util < int >::type ( int ) {
	return std::make_unique < type_details_type > ( "int" );
}

// ----------------------------------------------------------------------------------------------------------------

std::unique_ptr < type_details_base > type_util < char >::type ( char ) {
	return std::make_unique < type_details_type > ( "char" );
}

// ----------------------------------------------------------------------------------------------------------------

std::unique_ptr < type_details_base > type_util < bool >::type ( bool ) {
	return std::make_unique < type_details_type > ( "bool" );
}

// ----------------------------------------------------------------------------------------------------------------

std::unique_ptr < type_details_base > type_util < double >::type ( double ) {
	return std::make_unique < type_details_type > ( "double" );
}

// ----------------------------------------------------------------------------------------------------------------

std::unique_ptr < type_details_base > type_util < std::string >::type ( std::string ) {
	return std::make_unique < type_details_type > ( "std::string" );
}

// ----------------------------------------------------------------------------------------------------------------

std::unique_ptr < type_details_base > type_util < ext::ostream >::type ( const ext::ostream & ) {
	return std::make_unique < type_details_type > ( "ext::ostream" );
}

} /* namespace core */
