#pragma once

#include <ast/Expression.h>

namespace cli {

template < class Type >
class ImmediateExpression final : public Expression {
	Type m_value;

public:
	ImmediateExpression ( Type value ) : m_value ( std::move ( value ) ) {
	}

	std::shared_ptr < abstraction::Value > translateAndEval ( Environment & ) const override {
		Type copy = m_value;
		return std::make_shared < abstraction::ValueHolder < Type > > ( std::move ( copy ), true );
	}

};

} /* namespace cli */

